from cocos.scene import Scene
from pyglet import clock
from cocos.director import director
from cocos.layer import Layer,ColorLayer
from cocos.menu import Menu
from cocos.actions import *
from cocos.text import Label

from cocos.menu import *
import logging
log = logging.getLogger('LevelSelect')


import os,sys , string

from gamescene import GameLayer
from hud import HUD
from imagelayer import ImageLayer

class LevelsMenu( Menu ):

    def __init__(self, score):
        super( LevelsMenu, self).__init__() 

        
        self.font_title['color'] = (0,170,0,255)
        self.font_title['font_size'] = 20
        self.font_title['font_name'] = "M01_CPS"
        self.font_title['x'] = 400
        self.font_title['y'] = 200
        
        self.font_item['color'] = (255,255,255,255)
        self.font_item['font_size'] = 10
        self.font_item['font_name'] = "M01_CPS"
        
        self.font_item_selected['color'] = (0,200,0,255)
        self.font_item_selected['font_size'] = 12
        self.font_item_selected['font_name'] = "M01_CPS"

        self.menu_valign = BOTTOM
        self.menu_halign = CENTER

        self.score = score
        self.levelChoice = 0
        items = []
       
        path = os.path.abspath(os.path.dirname(__file__)+"/../data/levels")
        filenames = os.listdir(path) 
        print filenames

        self.levels = []
        director.return_value = 0
        
        items.append( MenuItem('Go', self.on_play) )
        
        for filename in filenames:
            if (string.count(filename, ".ini") > 0):
                name,ext = string.split(filename, '.')
                self.levels.append(name)
            
        items.append( MultipleMenuItem( 'Level: ',  self.on_level, self.levels ))

        self.create_menu( items )
        
        # Space em out
        pos = 0
        for menuItem in items:
            menuItem.y += 320-pos*10
            pos += 1
            
    def on_level(self, lev):
        self.levelChoice = self.levels[lev]
        
    def on_play( self ):
        colourLayer = ColorLayer(20,20,255,255) 
        hud = HUD()
        hud.score = int(director.return_value)
        log.info("starting level... "+str(director.return_value)+"score set to "+str(hud.score))
        gamelayer = GameLayer(hud, self.levelChoice)
        main_scene = Scene ( colourLayer, gamelayer, hud) 
        director.push(main_scene)
        
    def on_quit(self):
        director.scene.end() 

       
class LevelSelectScene(Scene):
    def __init__(self, score):
        super(LevelSelectScene, self).__init__()
        self.score = score
        self.add(ImageLayer("loadingscreen.png")) 
        self.add(LevelsMenu(score))
        x,y = director.get_window_size()
        title = Label("Choose level", font_size=20,font_name= "M01_CPS", color=(0,170,0,255))
        title.y = y*0.85
        title.x = 200
        self.add(title)
 
